"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Fragment(ProtocolElement):
    """
    A fragment represents a contiguous stretch of a DNA or RNA molecule.
    Reads can be associated with a fragment to specify they derive
    from the same molecule.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "id",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_8 import ga4gh as ga4gh_3_1_0

        return {
            "org.ga4gh.models.Fragment": ga4gh_3_1_0.Fragment,
        }

    __slots__ = [
        "id",
    ]

    def __init__(
        self,
        id,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_1_0.Fragment model.

        :param id:
            The fragment ID.
        :type id: str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.1.0"
